Attribute VB_Name = "Module1"
'**************************************************************************
'      Function, user-defined data type and Constant Declarations
'**************************************************************************
Public Type SCARD_IO_REQUEST
    dwProtocol As Long
    cbPciLength As Long
End Type

Public Type BytArray
    byBytes(601) As Byte
End Type

Public Type APDURec
    bCLA As Byte
    bINS As Byte
    bP1 As Byte
    bP2 As Byte
    bP3 As Byte
    Data(1 To 255) As Byte
    IsSend As Boolean
End Type

Public Type SCARD_READERSTATE
    szReader As String
    pvUserData As String
    dwCurrenState As Long
    dwEventState As Long
    lAtrLen As Long
    rgbAtr As BytArray
End Type

Public Type VERSION_CONTROL
    SmclibVersion As Long
    DriverMajor As Byte
    DriverMinor As Byte
    FirmwareMajor As Byte
    FirmwareMinor As Byte
    UpdateKey As Byte
End Type

' Our own constant declarations
Global Const MINTIMEOUT = 0
Global Const MAX_READERS = 8

' Constants used to access card and reader attributes

Global Const SCARD_CLASS_VENDOR_INFO = 1      ' Vendor information definitions
Global Const SCARD_CLASS_COMMUNICATIONS = 2   ' Communication definitions
Global Const SCARD_CLASS_PROTOCOL = 3         ' Protocol definitions
Global Const SCARD_CLASS_POWER_MGMT = 4       ' Power Management definitions
Global Const SCARD_CLASS_SECURITY = 5         ' Security Assurance definitions
Global Const SCARD_CLASS_MECHANICAL = 6       ' Mechanical characteristic definitions
Global Const SCARD_CLASS_VENDOR_DEFINED = 7   ' Vendor specific definitions
Global Const SCARD_CLASS_IFD_PROTOCOL = 8     ' Interface Device Protocol options
Global Const SCARD_CLASS_ICC_STATE = 9        ' ICC State specific definitions
Global Const SCARD_CLASS_SYSTEM = &H7FFF      ' System-specific definitions


Global Const SCARD_ATTR_VENDOR_NAME = (((SCARD_CLASS_VENDOR_INFO) * _
                                        (2 ^ 16)) Or (&H100))
                                        
Global Const SCARD_ATTR_VENDOR_IFD_TYPE = (((SCARD_CLASS_VENDOR_INFO) * _
                                            (2 ^ 16)) Or (&H101))

Global Const SCARD_ATTR_VENDOR_IFD_VERSION = (((SCARD_CLASS_VENDOR_INFO) * _
                                               (2 ^ 16)) Or (&H102))

Global Const SCARD_ATTR_VENDOR_IFD_SERIAL_NO = (((SCARD_CLASS_VENDOR_INFO) * _
                                                 (2 ^ 16)) Or (&H103))
                                            
Global Const SCARD_ATTR_CHANNEL_ID = (((SCARD_CLASS_COMMUNICATIONS) * _
                                       (2 ^ 16)) Or (&H110))
                                            
Global Const SCARD_ATTR_ASYNC_PROTOCOL_TYPES = (((SCARD_CLASS_PROTOCOL) * _
                                               (2 ^ 16)) Or (&H120))

Global Const SCARD_ATTR_DEFAULT_CLK = (((SCARD_CLASS_PROTOCOL) * _
                                        (2 ^ 16)) Or (&H121))

Global Const SCARD_ATTR_MAX_CLK = (((SCARD_CLASS_PROTOCOL) * _
                                    (2 ^ 16)) Or (&H122))

Global Const SCARD_ATTR_DEFAULT_DATA_RATE = (((SCARD_CLASS_PROTOCOL) * _
                                              (2 ^ 16)) Or (&H123))
    
Global Const SCARD_ATTR_MAX_DATA_RATE = (((SCARD_CLASS_PROTOCOL) * _
                                              (2 ^ 16)) Or (&H124))
 
Global Const SCARD_ATTR_MAX_IFSD = (((SCARD_CLASS_PROTOCOL) * _
                                              (2 ^ 16)) Or (&H125))
 
Global Const SCARD_ATTR_SYNC_PROTOCOL_TYPES = (((SCARD_CLASS_PROTOCOL) * _
                                              (2 ^ 16)) Or (&H126))
 


Global Const SCARD_ATTR_POWER_MGMT_SUPPORT = (((SCARD_CLASS_POWER_MGMT) * _
                                               (2 ^ 16)) Or (&H131))
                                               
Global Const SCARD_ATTR_USER_TO_CARD_AUTH_DEVICE = (((SCARD_CLASS_SECURITY) * _
                                                     (2 ^ 16)) Or (&H140))
                                                     
Global Const SCARD_ATTR_USER_AUTH_INPUT_DEVICE = (((SCARD_CLASS_SECURITY) * _
                                                   (2 ^ 16)) Or (&H142))
                                                   
Global Const SCARD_ATTR_CHARACTERISTICS = (((SCARD_CLASS_MECHANICAL) * _
                                            (2 ^ 16)) Or (&H150))


Global Const SCARD_ATTR_CURRENT_PROTOCOL_TYPE = (((SCARD_CLASS_IFD_PROTOCOL) * _
                                                  (2 ^ 16)) Or (&H201))
                                                  
Global Const SCARD_ATTR_CURRENT_CLK = (((SCARD_CLASS_IFD_PROTOCOL) * _
                                                  (2 ^ 16)) Or (&H202))
 
Global Const SCARD_ATTR_CURRENT_F = (((SCARD_CLASS_IFD_PROTOCOL) * _
                                                  (2 ^ 16)) Or (&H203))
 
Global Const SCARD_ATTR_CURRENT_D = (((SCARD_CLASS_IFD_PROTOCOL) * _
                                                  (2 ^ 16)) Or (&H204))
 
Global Const SCARD_ATTR_CURRENT_N = (((SCARD_CLASS_IFD_PROTOCOL) * _
                                                  (2 ^ 16)) Or (&H205))
 
Global Const SCARD_ATTR_CURRENT_W = (((SCARD_CLASS_IFD_PROTOCOL) * _
                                                  (2 ^ 16)) Or (&H206))
 
Global Const SCARD_ATTR_CURRENT_IFSC = (((SCARD_CLASS_IFD_PROTOCOL) * _
                                                  (2 ^ 16)) Or (&H207))
 
Global Const SCARD_ATTR_CURRENT_IFSD = (((SCARD_CLASS_IFD_PROTOCOL) * _
                                                  (2 ^ 16)) Or (&H208))
 
Global Const SCARD_ATTR_CURRENT_BWT = (((SCARD_CLASS_IFD_PROTOCOL) * _
                                                  (2 ^ 16)) Or (&H209))
 
Global Const SCARD_ATTR_CURRENT_CWT = (((SCARD_CLASS_IFD_PROTOCOL) * _
                                                  (2 ^ 16)) Or (&H20A))
 
Global Const SCARD_ATTR_CURRENT_EBC_ENCODING = (((SCARD_CLASS_IFD_PROTOCOL) * _
                                                  (2 ^ 16)) Or (&H20B))
 
Global Const SCARD_ATTR_EXTENDED_BWT = (((SCARD_CLASS_IFD_PROTOCOL) * _
                                                  (2 ^ 16)) Or (&H20C))
 

Global Const SCARD_ATTR_ICC_PRESENCE = (((SCARD_CLASS_ICC_STATE) * _
                                         (2 ^ 16)) Or (&H300))
                                         
Global Const SCARD_ATTR_ICC_INTERFACE_STATUS = (((SCARD_CLASS_ICC_STATE) * _
                                         (2 ^ 16)) Or (&H301))
 
Global Const SCARD_ATTR_CURRENT_IO_STATE = (((SCARD_CLASS_ICC_STATE) * _
                                         (2 ^ 16)) Or (&H302))
 
Global Const SCARD_ATTR_ATR_STRING = (((SCARD_CLASS_ICC_STATE) * _
                                         (2 ^ 16)) Or (&H303))
 
Global Const SCARD_ATTR_ICC_TYPE_PER_ATR = (((SCARD_CLASS_ICC_STATE) * _
                                         (2 ^ 16)) Or (&H304))
 

Global Const SCARD_ATTR_ESC_RESET = (((SCARD_CLASS_VENDOR_DEFINED) * _
                                      (2 ^ 16)) Or (&HA000))
                                      
Global Const SCARD_ATTR_ESC_CANCEL = (((SCARD_CLASS_VENDOR_DEFINED) * _
                                      (2 ^ 16)) Or (&HA003))
 
Global Const SCARD_ATTR_ESC_AUTHREQUEST = (((SCARD_CLASS_VENDOR_DEFINED) * _
                                      (2 ^ 16)) Or (&HA005))
 
Global Const SCARD_ATTR_MAXINPUT = (((SCARD_CLASS_VENDOR_DEFINED) * _
                                      (2 ^ 16)) Or (&HA007))
 
 
Global Const SCARD_ATTR_DEVICE_UNIT = (((SCARD_CLASS_SYSTEM) * _
                                        (2 ^ 16)) Or (&H1))
                                        
Global Const SCARD_ATTR_DEVICE_IN_USE = (((SCARD_CLASS_SYSTEM) * _
                                        (2 ^ 16)) Or (&H2))
 
Global Const SCARD_ATTR_DEVICE_FRIENDLY_NAME_A = (((SCARD_CLASS_SYSTEM) * _
                                        (2 ^ 16)) Or (&H3))
 
Global Const SCARD_ATTR_DEVICE_SYSTEM_NAME_A = (((SCARD_CLASS_SYSTEM) * _
                                        (2 ^ 16)) Or (&H4))
 
Global Const SCARD_ATTR_DEVICE_FRIENDLY_NAME_W = (((SCARD_CLASS_SYSTEM) * _
                                        (2 ^ 16)) Or (&H5))
 
Global Const SCARD_ATTR_DEVICE_SYSTEM_NAME_W = (((SCARD_CLASS_SYSTEM) * _
                                        (2 ^ 16)) Or (&H6))
 
Global Const SCARD_ATTR_SUPRESS_T1_IFS_REQUEST = (((SCARD_CLASS_SYSTEM) * _
                                        (2 ^ 16)) Or (&H7))
 
Global Const SCARD_ATTR_DEVICE_FRIENDLY_NAME = SCARD_ATTR_DEVICE_FRIENDLY_NAME_A

Global Const SCARD_ATTR_DEVICE_SYSTEM_NAME = SCARD_ATTR_DEVICE_SYSTEM_NAME_A


'**************************************************************************
' IO_CTL Codes
'**************************************************************************

Global Const METHOD_BUFFERED = 0
Global Const METHOD_IN_DIRECT = 1
Global Const METHOD_OUT_DIRECT = 2
Global Const METHOD_NEITHER = 3

Global Const FILE_ANY_ACCESS = &H0
Global Const FILE_READ_ACCESS = &H1
Global Const FILE_WRITE_ACCESS = &H2

Global Const FILE_DEVICE_SMARTCARD = &H31

Global Const IOCTL_PSCR_COMMAND = (((FILE_DEVICE_SMARTCARD) * (2 ^ 16)) Or _
                                    ((FILE_ANY_ACCESS) * (2 ^ 14)) Or _
                                    ((&H800) * (2 ^ 2)) Or _
                                    (METHOD_BUFFERED))

Global Const IOCTL_GET_VERSIONS = (((FILE_DEVICE_SMARTCARD) * (2 ^ 16)) Or _
                                    ((FILE_ANY_ACCESS) * (2 ^ 14)) Or _
                                    ((&H801) * (2 ^ 2)) Or _
                                    (METHOD_BUFFERED))

Global Const IOCTL_SET_TIMEOUT = (((FILE_DEVICE_SMARTCARD) * (2 ^ 16)) Or _
                                    ((FILE_ANY_ACCESS) * (2 ^ 14)) Or _
                                    ((&H802) * (2 ^ 2)) Or _
                                    (METHOD_BUFFERED))

Global Const IOCTL_RESET_INTERFACE = (((FILE_DEVICE_SMARTCARD) * (2 ^ 16)) Or _
                                    ((FILE_ANY_ACCESS) * (2 ^ 14)) Or _
                                    ((&H803) * (2 ^ 2)) Or _
                                    (METHOD_BUFFERED))

Global Const IOCTL_GET_CONFIGURATION = (((FILE_DEVICE_SMARTCARD) * (2 ^ 16)) Or _
                                    ((FILE_ANY_ACCESS) * (2 ^ 14)) Or _
                                    ((&H804) * (2 ^ 2)) Or _
                                    (METHOD_BUFFERED))

Global Const IOCTL_SCM_PINPAD = (((FILE_DEVICE_SMARTCARD) * (2 ^ 16)) Or _
                                    ((FILE_ANY_ACCESS) * (2 ^ 14)) Or _
                                    ((&H805) * (2 ^ 2)) Or _
                                    (METHOD_BUFFERED))

Global Const IOCTL_SCM_SET_P = (((FILE_DEVICE_SMARTCARD) * (2 ^ 16)) Or _
                                    ((FILE_ANY_ACCESS) * (2 ^ 14)) Or _
                                    ((&H811) * (2 ^ 2)) Or _
                                    (METHOD_BUFFERED))

Global Const IOCTL_SCM_GET_P = (((FILE_DEVICE_SMARTCARD) * (2 ^ 16)) Or _
                                    ((FILE_ANY_ACCESS) * (2 ^ 14)) Or _
                                    ((&H812) * (2 ^ 2)) Or _
                                    (METHOD_BUFFERED))

Global Const IOCTL_GET_DEVICE_NAME = (((FILE_DEVICE_SMARTCARD) * (2 ^ 16)) Or _
                                    ((FILE_ANY_ACCESS) * (2 ^ 14)) Or _
                                    ((&H820) * (2 ^ 2)) Or _
                                    (METHOD_BUFFERED))


'**************************************************************************
' Context Scope
'**************************************************************************
' The context is a user context, and any database operations are performed
' within the domain of the user.
Global Const SCARD_SCOPE_USER = 0

' The context is that of the current terminal,and any database operations
' are performed within the domain of that terminal. (The calling application
' must have appropriate access permissions for any database actions.)
Global Const SCARD_SCOPE_TERMINAL = 1

' The context is the system context, and any database operations are performed
' within the domain of the system.  (The calling application must have appropriate
' access permissions for any database actions.)
Global Const SCARD_SCOPE_SYSTEM = 2

'**************************************************************************
' Context Scope
'**************************************************************************
Global Const SCARD_S_SUCCESS = 0
Global Const SCARD_ATR_LENGTH = 33

' The application is unaware of the current state, and would like to
' know.  The use of this value results in an immediate return from state transition
' monitoring services.  This is represented by all bits set to zero.
Global Const SCARD_STATE_UNAWARE = &H0

' The application requested that this reader be ignored.  No other bits will be set.
Global Const SCARD_STATE_IGNORE = &H1

' This implies that there is a difference between the state believed by the
' application, and the state known by the Service Manager.  When this bit is set,
' the application may assume a significant state change has occurred on this reader.
Global Const SCARD_STATE_CHANGED = &H2

' This implies that the given reader name is not recognized by the Service Manager.
' If this bit is set, then SCARD_STATE_CHANGED and SCARD_STATE_IGNORE will also
' be set.
Global Const SCARD_STATE_UNKNOWN = &H4

' This implies that the actual state of this reader is not
' available.  If this bit is set, then all the following bits are clear.
Global Const SCARD_STATE_UNAVAILABLE = &H8

Global Const SCARD_STATE_EMPTY = &H10 ' This implies that there is not
                                            ' card in the reader.  If this bit
                                            ' is set, all the following bits
                                            ' will be clear.
Global Const SCARD_STATE_PRESENT = &H20 ' This implies that there is a card
                                            ' in the reader.
Global Const SCARD_STATE_ATRMATCH = &H40 ' This implies that there is a card
                                            ' in the reader with an ATR
                                            ' matching one of the target cards.
                                            ' If this bit is set,
                                            ' SCARD_STATE_PRESENT will also be
                                            ' set.  This bit is only returned
                                            ' on the SCardLocateCard() service.
Global Const SCARD_STATE_EXCLUSIVE = &H80 ' This implies that the card in the
                                            ' reader is allocated for exclusive
                                            ' use by another application.  If
                                            ' this bit is set,
                                            ' SCARD_STATE_PRESENT will also be
                                            ' set.
' This implies that the card in the reader is in use by one or more
' other applications, but may be connected to in shared mode.  If
' this bit is set, SCARD_STATE_PRESENT will also be set.
Global Const SCARD_STATE_INUSE = &H100

' This implies that the card in the reader is unresponsive or not
' supported by the reader or software.
Global Const SCARD_STATE_MUTE = &H200

' This implies that the card in the reader has not been powered up.
Global Const SCARD_STATE_UNPOWERED = &H400


'**************************************************************************
'
'**************************************************************************
' This application is not willing to share this card with other applications.
Global Const SCARD_SHARE_EXCLUSIVE = 1

' This application is willing to share this card with other applications.
Global Const SCARD_SHARE_SHARED = 2

' This application demands direct control of the reader,
' so it is not available to other applications.
Global Const SCARD_SHARE_DIRECT = 3

'**************************************************************************
'   Disposition
'**************************************************************************
' Don't do anything special on close
Global Const SCARD_LEAVE_CARD = 0

' Reset the card on close
Global Const SCARD_RESET_CARD = 1

' Power down the card on close
Global Const SCARD_UNPOWER_CARD = 2

' Eject the card on close
Global Const SCARD_EJECT_CARD = 3

'**************************************************************************
'   Error Codes
'**************************************************************************
Global Const SCARD_F_INTERNAL_ERROR = &H80100001
Global Const SCARD_E_CANCELLED = &H80100002
Global Const SCARD_E_INVALID_HANDLE = &H80100003
Global Const SCARD_E_INVALID_PARAMETER = &H80100004
Global Const SCARD_E_INVALID_TARGET = &H80100005
Global Const SCARD_E_NO_MEMORY = &H80100006
Global Const SCARD_F_WAITED_TOO_LONG = &H80100007
Global Const SCARD_E_INSUFFICIENT_BUFFER = &H80100008
Global Const SCARD_E_UNKNOWN_READER = &H80100009
Global Const SCARD_E_TIMEOUT = &H8010000A
Global Const SCARD_E_SHARING_VIOLATION = &H8010000B
Global Const SCARD_E_NO_SMARTCARD = &H8010000C
Global Const SCARD_E_UNKNOWN_CARD = &H8010000D
Global Const SCARD_E_CANT_DISPOSE = &H8010000E
Global Const SCARD_E_PROTO_MISMATCH = &H8010000F
Global Const SCARD_E_NOT_READY = &H80100010
Global Const SCARD_E_INVALID_VALUE = &H80100011
Global Const SCARD_E_SYSTEM_CANCELLED = &H80100012
Global Const SCARD_F_COMM_ERROR = &H80100013
Global Const SCARD_F_UNKNOWN_ERROR = &H80100014
Global Const SCARD_E_INVALID_ATR = &H80100015
Global Const SCARD_E_NOT_TRANSACTED = &H80100016
Global Const SCARD_E_READER_UNAVAILABLE = &H80100017
Global Const SCARD_P_SHUTDOWN = &H80100018
Global Const SCARD_E_PCI_TOO_SMALL = &H80100019
Global Const SCARD_E_READER_UNSUPPORTED = &H8010001A
Global Const SCARD_E_DUPLICATE_READER = &H8010001B
Global Const SCARD_E_CARD_UNSUPPORTED = &H8010001C
Global Const SCARD_E_NO_SERVICE = &H8010001D
Global Const SCARD_E_SERVICE_STOPPED = &H8010001E
Global Const SCARD_W_UNSUPPORTED_CARD = &H80100065
Global Const SCARD_W_UNRESPONSIVE_CARD = &H80100066
Global Const SCARD_W_UNPOWERED_CARD = &H80100067
Global Const SCARD_W_RESET_CARD = &H80100068
Global Const SCARD_W_REMOVED_CARD = &H80100069


'**************************************************************************
'   Protocol
'**************************************************************************
' There is no active protocol.
Global Const SCARD_PROTOCOL_UNDEFINED = &H0

' T=0 is the active protocol.
Global Const SCARD_PROTOCOL_T0 = &H1

' T=1 is the active protocol.
Global Const SCARD_PROTOCOL_T1 = &H2

' Raw is the active protocol.
Global Const SCARD_PROTOCOL_RAW = &H10000

' Use implicit PTS.
Global Const SCARD_PROTOCOL_DEFAULT = &H80000000


'**************************************************************************
'   Reader State
'**************************************************************************
' This value implies the driver is unaware
' of the current state of the reader.
Global Const SCARD_UNKNOWN = 0

' This value implies there is no card in
' the reader.
Global Const SCARD_ABSENT = 1
                                  
' This value implies there is a card is
' present in the reader, but that it has
' not been moved into position for use.
Global Const SCARD_PRESENT = 2

' This value implies there is a card in the
' reader in position for use.  The card is
' not powered.
Global Const SCARD_SWALLOWED = 3

' This value implies there is power is
' being provided to the card, but the
' Reader Driver is unaware of the mode of
' the card.
Global Const SCARD_POWERED = 4

' This value implies the card has been
' reset and is awaiting PTS negotiation.
Global Const SCARD_NEGOTIABLE = 5

' This value implies the card has been
' reset and specific communication
' protocols have been established.
Global Const SCARD_SPECIFIC = 6

'**************************************************************************
' Prototypes
'**************************************************************************
Public Declare Function SCardEstablishContext Lib "WinScard.dll" ( _
    ByVal dwScope As Long, _
    ByVal pvReserved1 As Long, _
    ByVal pvReserved2 As Long, _
    ByRef phContext As Long _
) As Long

'**************************************************************************
Public Declare Function SCardReleaseContext Lib "WinScard.dll" ( _
    ByVal hContext As Long _
) As Long

'**************************************************************************
Public Declare Function SCardConnect Lib "WinScard.dll" Alias "SCardConnectA" ( _
    ByVal hContext As Long, _
    ByVal szReaderName As String, _
    ByVal dwShareMode As Long, _
    ByVal dwPrefProtocol As Long, _
    ByRef hCard As Long, _
    ByRef ActiveProtocol As Long _
) As Long
                                                         
'**************************************************************************
Public Declare Function SCardDisconnect Lib "WinScard.dll" ( _
    ByVal hCard As Long, _
    ByVal Disposistion As Long _
) As Long

'**************************************************************************
Public Declare Function SCardBeginTransaction Lib "WinScard.dll" ( _
    ByVal hCard As Long _
) As Long

'**************************************************************************
Public Declare Function SCardEndTransaction Lib "WinScard.dll" ( _
    ByVal hCard As Long, _
    ByVal Disposition As Long _
) As Long

'**************************************************************************
Public Declare Function SCardState Lib "WinScard.dll" ( _
    ByVal hCard As Long, _
    ByRef State As Long, _
    ByRef Protocol As Long, _
    ByRef ATR As Byte, _
    ByRef ATRLen As Long _
) As Long

'**************************************************************************
Public Declare Function SCardStatus Lib "WinScard.dll" Alias "SCardStatusA" ( _
    ByVal hCard As Long, _
    ByVal szReaderName As String, _
    ByRef pcchReaderLen As Long, _
    ByRef State As Long, _
    ByRef Protocol As Long, _
    ByRef ATR As BytArray, _
    ByRef ATRLen As Long _
) As Long

'**************************************************************************
Public Declare Function SCardTransmit Lib "WinScard.dll" ( _
    ByVal hCard As Long, _
    ByVal pioSendRequest As Long, _
    ByRef SendBuff As BytArray, _
    ByVal SendBuffLen As Long, _
    ByVal pioRecvRequest As Long, _
    ByRef RecvBuff As BytArray, _
    ByRef RecvBuffLen As Long _
) As Long
                                                          
'**************************************************************************
Public Declare Function SCardListReaders Lib "WinScard.dll" Alias "SCardListReadersA" ( _
    ByVal hContext As Long, _
    ByVal mzGroup As String, _
    ByVal ReaderList As String, _
    ByRef pcchReaders As Long _
) As Long

'**************************************************************************
Public Declare Function SCardCancel Lib "WinScard.dll" ( _
    ByVal hContext As Long _
) As Long

'**************************************************************************
Public Declare Function SCardSetAttrib Lib "WinScard.dll" ( _
    ByVal hCard As Long, _
    ByVal dwAttrId As Long, _
    ByVal pbAttr As BytArray, _
    ByVal lAttrLen As Long _
) As Long

'**************************************************************************
Public Declare Function SCardGetStatusChange Lib "WinScard.dll" Alias _
                       "SCardGetStatusChangeA" ( _
    ByVal hContext As Long, _
    ByVal dwTimeOut As Long, _
    ByRef rgReaderStates As SCARD_READERSTATE, _
    ByVal cReaders As Long _
) As Long
'**************************************************************************
Public Declare Function SCardControl Lib "WinScard.dll" ( _
    ByVal hCard As Long, _
    ByVal dwControlCode As Long, _
    ByVal lpInBuffer As Long, _
    ByVal lSizeofBuffer As Long, _
    ByRef lpReceiveBuffer As VERSION_CONTROL, _
    ByVal lpReceiveBufferSize As Long, _
    ByRef lpBytesReturned As Long _
) As Long

'**************************************************************************
Public Declare Function SCardGetAttrib Lib "WinScard.dll" ( _
    ByVal hCard As Long, _
    ByVal dwAttrId As Long, _
    ByRef pbAttr As BytArray, _
    ByRef pcbAttrLen As Long _
) As Long

'**************************************************************************
